Index: /code/branches/cpp11_v2/src/libraries/core/BaseObject.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/BaseObject.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/BaseObject.cc	(revision 10916)
@@ -234,8 +234,8 @@
     {
         unsigned int i = 0;
-        for (const auto & elem : this->templates_)
+        for (Template* temp : this->templates_)
         {
             if (i == index)
-                return (elem);
+                return temp;
             i++;
         }
@@ -269,11 +269,11 @@
     {
         unsigned int i = 0;
-        for (const auto & elem : this->eventSources_)
-        {
-            if (elem.second != state)
+        for (const auto& mapEntry : this->eventSources_)
+        {
+            if (mapEntry.second != state)
                 continue;
 
             if (i == index)
-                return elem.first;
+                return mapEntry.first;
             ++i;
         }
@@ -296,8 +296,8 @@
     {
         unsigned int i = 0;
-        for (const auto & elem : this->eventListenersXML_)
+        for (BaseObject* listener : this->eventListenersXML_)
         {
             if (i == index)
-                return elem;
+                return listener;
             ++i;
         }
@@ -358,8 +358,8 @@
         Event event(activate, originator, name);
 
-        for (const auto & elem : this->eventListeners_)
-        {
-            event.statename_ = (elem)->eventSources_[this];
-            (elem)->processEvent(event);
+        for (BaseObject* listener : this->eventListeners_)
+        {
+            event.statename_ = listener->eventSources_[this];
+            listener->processEvent(event);
         }
     }
@@ -370,6 +370,6 @@
     void BaseObject::fireEvent(Event& event)
     {
-        for (const auto & elem : this->eventListeners_)
-            (elem)->processEvent(event);
+        for (BaseObject* listener : this->eventListeners_)
+            listener->processEvent(event);
     }
 
@@ -474,8 +474,6 @@
 
             // iterate through all states and get the event sources
-            for (auto & statename : eventnames)
-            {
-                
-
+            for (const std::string& statename : eventnames)
+            {
                 // if the event state is already known, continue with the next state
                 orxonox::EventState* eventstate = object->getEventState(statename);
Index: /code/branches/cpp11_v2/src/libraries/core/ClassTreeMask.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/ClassTreeMask.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/ClassTreeMask.cc	(revision 10916)
@@ -293,8 +293,8 @@
         {
             // No it's not: Search for classes inheriting from the given class and add the rules for them
-            for (const auto & elem : subclass->getDirectChildren())
-                if ((elem)->isA(this->root_->getClass()))
-                    if (overwrite || (!this->nodeExists(elem))) // If we don't want to overwrite, only add nodes that don't already exist
-                        this->add(this->root_, elem, bInclude, overwrite);
+            for (const Identifier* directChild : subclass->getDirectChildren())
+                if (directChild->isA(this->root_->getClass()))
+                    if (overwrite || (!this->nodeExists(directChild))) // If we don't want to overwrite, only add nodes that don't already exist
+                        this->add(this->root_, directChild, bInclude, overwrite);
         }
 
@@ -325,10 +325,10 @@
         {
             // Search for an already existing node, containing the subclass we want to add
-            for (auto & elem : node->subnodes_)
+            for (ClassTreeMaskNode* subnode : node->subnodes_)
             {
-                if (subclass->isA((elem)->getClass()))
+                if (subclass->isA(subnode->getClass()))
                 {
                     // We've found an existing node -> delegate the work with a recursive function-call and return
-                    this->add(elem, subclass, bInclude, overwrite);
+                    this->add(subnode, subclass, bInclude, overwrite);
                     return;
                 }
@@ -392,6 +392,6 @@
         if (!subclass)
             return;
-        for (const auto & elem : subclass->getDirectChildren())
-            this->add(elem, this->isIncluded(elem), false, false);
+        for (const Identifier* directChild : subclass->getDirectChildren())
+            this->add(directChild, this->isIncluded(directChild), false, false);
 
         this->add(subclass, bInclude, false, clean);
@@ -435,7 +435,7 @@
 
             // Go through the list of subnodes and look for a node containing the searched subclass and delegate the request by a recursive function-call.
-            for (auto & elem : node->subnodes_)
-                if (subclass->isA((elem)->getClass()))
-                    return isIncluded(elem, subclass);
+            for (ClassTreeMaskNode* subnode : node->subnodes_)
+                if (subclass->isA(subnode->getClass()))
+                    return isIncluded(subnode, subclass);
 
             // There is no subnode containing our class -> the rule of the current node takes in effect
@@ -957,6 +957,6 @@
             // The bool is "false", meaning they have no subnodes and therefore need no further checks
             if (node->isIncluded())
-                for (const auto & elem : directChildren)
-                    this->subclasses_.insert(this->subclasses_.end(), std::pair<const Identifier*, bool>(elem, false));
+                for (const Identifier* directChild : directChildren)
+                    this->subclasses_.insert(this->subclasses_.end(), std::pair<const Identifier*, bool>(directChild, false));
         }
     }
Index: /code/branches/cpp11_v2/src/libraries/core/Core.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/Core.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/Core.cc	(revision 10916)
@@ -279,5 +279,5 @@
 
         const std::vector<std::string>& modulePaths = ApplicationPaths::getInstance().getModulePaths();
-        for (const auto & modulePath : modulePaths)
+        for (const std::string& modulePath : modulePaths)
         {
             ModuleInstance* module = new ModuleInstance(modulePath);
@@ -309,7 +309,6 @@
     void Core::unloadModules()
     {
-        for (auto module : this->modules_)
-        {
-            
+        for (ModuleInstance* module : this->modules_)
+        {
             this->unloadModule(module);
             delete module;
Index: /code/branches/cpp11_v2/src/libraries/core/CoreStaticInitializationHandler.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/CoreStaticInitializationHandler.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/CoreStaticInitializationHandler.cc	(revision 10916)
@@ -99,5 +99,5 @@
         std::set<Identifier*> identifiers;
         const std::set<StaticallyInitializedInstance*>& instances = module->getInstances(StaticInitialization::IDENTIFIER);
-        for (const auto & instance : instances)
+        for (StaticallyInitializedInstance* instance : instances)
             identifiers.insert(&static_cast<StaticallyInitializedIdentifier*>(instance)->getIdentifier());
 
@@ -106,16 +106,16 @@
         // that objects within one module may reference each other by strong pointers. but it is not allowed that objects from another
         // module (which is not unloaded) uses strong pointers to point at objects inside the unloaded module. this will lead to a crash.
-        for (const auto & identifier : identifiers)
-            (identifier)->destroyObjects();
+        for (Identifier* identifier : identifiers)
+            identifier->destroyObjects();
 
         // check if all objects were really destroyed. this is not the case if an object is referenced by a strong pointer from another
         // module (or if two objects inside this module reference each other). this will lead to a crash and must be fixed (e.g. by
         // changing object dependencies; or by changing the logic that allows modules to be unloaded).
-        for (const auto & identifier : identifiers)
+        for (Identifier* identifier : identifiers)
         {
             ObjectListBase* objectList = Context::getRootContext()->getObjectList(identifier);
             if (objectList->size() > 0)
             {
-                orxout(internal_error) << "There are still " << objectList->size() << " objects of type " << (identifier)->getName()
+                orxout(internal_error) << "There are still " << objectList->size() << " objects of type " << identifier->getName()
                     << " after unloading the Identifier. This may lead to a crash" << endl;
             }
@@ -123,12 +123,12 @@
 
         // destroy object-lists in all contexts
-        for (const auto & identifier : identifiers)
+        for (Identifier* identifier : identifiers)
         {
             // only do this if the Identifier is not a Context itself; otherwise we delete the list we're iterating over
-            if (!(identifier)->isExactlyA(Class(Context)))
+            if (!identifier->isExactlyA(Class(Context)))
             {
                 // iterate over all contexts
                 for (ObjectList<Context>::iterator it_context = ObjectList<Context>::begin(); it_context != ObjectList<Context>::end(); ++it_context)
-                    it_context->destroyObjectList((identifier));
+                    it_context->destroyObjectList(identifier);
             }
         }
Index: /code/branches/cpp11_v2/src/libraries/core/Game.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/Game.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/Game.cc	(revision 10916)
@@ -612,6 +612,6 @@
         // Check if graphics is still required
         bool graphicsRequired = false;
-        for (auto & elem : loadedStates_)
-            graphicsRequired |= elem->getInfo().bGraphicsMode;
+        for (const std::shared_ptr<GameState>& state : loadedStates_)
+            graphicsRequired |= state->getInfo().bGraphicsMode;
         if (!graphicsRequired)
             this->unloadGraphics(!this->bAbort_); // if abort is false, that means the game is still running while unloading graphics. in this case we load a graphics manager without renderer (to keep all necessary ogre instances alive)
Index: /code/branches/cpp11_v2/src/libraries/core/Language.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/Language.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/Language.cc	(revision 10916)
@@ -107,6 +107,6 @@
     Language::~Language()
     {
-        for (auto & elem : this->languageEntries_)
-            delete (elem.second);
+        for (auto& mapEntry : this->languageEntries_)
+            delete (mapEntry.second);
     }
 
@@ -319,7 +319,7 @@
 
         // Iterate through the list an write the lines into the file
-        for (const auto & elem : this->languageEntries_)
-        {
-            file << elem.second->getLabel() << '=' << elem.second->getDefault() << endl;
+        for (const auto& mapEntry : this->languageEntries_)
+        {
+            file << mapEntry.second->getLabel() << '=' << mapEntry.second->getDefault() << endl;
         }
 
Index: /code/branches/cpp11_v2/src/libraries/core/Loader.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/Loader.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/Loader.cc	(revision 10916)
@@ -165,7 +165,7 @@
                         std::ostringstream message;
                         message << "Possible sources of error:" << endl;
-                        for (auto & linesource : linesources)
+                        for (const std::pair<std::string, size_t>& pair : linesources)
                         {
-                            message << linesource.first << ", Line " << linesource.second << endl;
+                            message << pair.first << ", Line " << pair.second << endl;
                         }
                         orxout(user_error, context::loader) << message.str() << endl;
@@ -261,7 +261,7 @@
         {
             bool expectedValue = true;
-            for (auto & luaTag : luaTags)
-            {
-                if (luaTag.second == expectedValue)
+            for (auto& mapEntry : luaTags)
+            {
+                if (mapEntry.second == expectedValue)
                     expectedValue = !expectedValue;
                 else
Index: /code/branches/cpp11_v2/src/libraries/core/LuaState.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/LuaState.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/LuaState.cc	(revision 10916)
@@ -326,7 +326,7 @@
     /*static*/ bool LuaState::addToluaInterface(int (*function)(lua_State*), const std::string& name)
     {
-        for (const auto & interface : getToluaInterfaces())
-        {
-            if (interface.first == name || interface.second == function)
+        for (const auto& mapEntry : getToluaInterfaces())
+        {
+            if (mapEntry.first == name || mapEntry.second == function)
             {
                 orxout(internal_warning, context::lua) << "Trying to add a Tolua interface with the same name or function." << endl;
@@ -337,5 +337,5 @@
 
         // Open interface in all LuaStates
-        for (const auto & state : getInstances())
+        for (LuaState* state : getInstances())
             (*function)(state->luaState_);
 
@@ -354,5 +354,5 @@
 
         // Close interface in all LuaStates
-        for (const auto & state : getInstances())
+        for (LuaState* state : getInstances())
         {
             lua_pushnil(state->luaState_);
@@ -369,14 +369,14 @@
     /*static*/ void LuaState::openToluaInterfaces(lua_State* state)
     {
-        for (const auto & interface : getToluaInterfaces())
-            (interface.second)(state);
+        for (const auto& mapEntry : getToluaInterfaces())
+            (mapEntry.second)(state);
     }
 
     /*static*/ void LuaState::closeToluaInterfaces(lua_State* state)
     {
-        for (const auto & interface : getToluaInterfaces())
+        for (const auto& mapEntry : getToluaInterfaces())
         {
             lua_pushnil(state);
-            lua_setglobal(state, interface.first.c_str());
+            lua_setglobal(state, mapEntry.first.c_str());
         }
     }
Index: /code/branches/cpp11_v2/src/libraries/core/NamespaceNode.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/NamespaceNode.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/NamespaceNode.cc	(revision 10916)
@@ -103,9 +103,9 @@
                 bool bFoundMatchingNamespace = false;
 
-                for (auto & elem : this->subnodes_)
+                for (auto& mapEntry : this->subnodes_)
                 {
-                    if (elem.first.find(firstPart) == (elem.first.size() - firstPart.size()))
+                    if (mapEntry.first.find(firstPart) == (mapEntry.first.size() - firstPart.size()))
                     {
-                        std::set<NamespaceNode*> temp2 = elem.second->getNodeRelative(secondPart);
+                        std::set<NamespaceNode*> temp2 = mapEntry.second->getNodeRelative(secondPart);
                         nodes.insert(temp2.begin(), temp2.end());
                         bFoundMatchingNamespace = true;
@@ -132,6 +132,6 @@
         else
         {
-            for (const auto & elem : this->subnodes_)
-                if (elem.second->includes(ns))
+            for (const auto& mapEntry : this->subnodes_)
+                if (mapEntry.second->includes(ns))
                     return true;
         }
@@ -167,6 +167,6 @@
         std::string output = (indentation + this->name_ + '\n');
 
-        for (const auto & elem : this->subnodes_)
-            output += elem.second->toString(indentation + "  ");
+        for (const auto& mapEntry : this->subnodes_)
+            output += mapEntry.second->toString(indentation + "  ");
 
         return output;
Index: /code/branches/cpp11_v2/src/libraries/core/Resource.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/Resource.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/Resource.cc	(revision 10916)
@@ -58,5 +58,5 @@
         DataStreamListPtr resources(new Ogre::DataStreamList());
         const Ogre::StringVector& groups = Ogre::ResourceGroupManager::getSingleton().getResourceGroups();
-        for (const auto & group : groups)
+        for (const std::string& group : groups)
         {
             DataStreamListPtr temp = Ogre::ResourceGroupManager::getSingleton().openResources(pattern, group);
@@ -121,5 +121,5 @@
         StringVectorPtr resourceNames(new Ogre::StringVector());
         const Ogre::StringVector& groups = Ogre::ResourceGroupManager::getSingleton().getResourceGroups();
-        for (const auto & group : groups)
+        for (const std::string& group : groups)
         {
             StringVectorPtr temp = Ogre::ResourceGroupManager::getSingleton().findResourceNames(group, pattern);
Index: /code/branches/cpp11_v2/src/libraries/core/class/Identifier.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/class/Identifier.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/class/Identifier.cc	(revision 10916)
@@ -87,15 +87,15 @@
         for (std::list<const Identifier*>::const_iterator it = this->directParents_.begin(); it != this->directParents_.end(); ++it)
             const_cast<Identifier*>(*it)->directChildren_.erase(this);
-        for (const auto & elem : this->children_)
-            const_cast<Identifier*>(elem)->parents_.remove(this);
-        for (const auto & elem : this->directChildren_)
-            const_cast<Identifier*>(elem)->directParents_.remove(this);
-
-        for (auto & elem : this->configValues_)
-            delete (elem.second);
-        for (auto & elem : this->xmlportParamContainers_)
-            delete (elem.second);
-        for (auto & elem : this->xmlportObjectContainers_)
-            delete (elem.second);
+        for (const Identifier* child : this->children_)
+            const_cast<Identifier*>(child)->parents_.remove(this);
+        for (const Identifier* directChild : this->directChildren_)
+            const_cast<Identifier*>(directChild)->directParents_.remove(this);
+
+        for (auto& mapEntry : this->configValues_)
+            delete (mapEntry.second);
+        for (auto& mapEntry : this->xmlportParamContainers_)
+            delete (mapEntry.second);
+        for (auto& mapEntry : this->xmlportObjectContainers_)
+            delete (mapEntry.second);
     }
 
@@ -157,7 +157,7 @@
         if (this->directParents_.empty())
         {
-            for (const auto & elem : initializationTrace)
-                if (elem != this)
-                    this->parents_.push_back(elem);
+            for (const Identifier* identifier : initializationTrace)
+                if (identifier != this)
+                    this->parents_.push_back(identifier);
         }
         else
@@ -261,20 +261,20 @@
 
         // if any parent class is virtual, it will be instantiated first, so we need to add them first.
-        for (const auto & elem : this->parents_)
-        {
-            if ((elem)->isVirtualBase())
+        for (const Identifier* parent : this->parents_)
+        {
+            if (parent->isVirtualBase())
             {
-                for (std::list<const Identifier*>::const_iterator it_parent_parent = const_cast<Identifier*>(elem)->parents_.begin(); it_parent_parent != const_cast<Identifier*>(elem)->parents_.end(); ++it_parent_parent)
+                for (std::list<const Identifier*>::const_iterator it_parent_parent = const_cast<Identifier*>(parent)->parents_.begin(); it_parent_parent != const_cast<Identifier*>(parent)->parents_.end(); ++it_parent_parent)
                     this->addIfNotExists(expectedIdentifierTrace, *it_parent_parent);
-                this->addIfNotExists(expectedIdentifierTrace, elem);
+                this->addIfNotExists(expectedIdentifierTrace, parent);
             }
         }
 
         // now all direct parents get created recursively. already added identifiers (e.g. virtual base classes) are not added again.
-        for (const auto & elem : this->directParents_)
-        {
-            for (std::list<const Identifier*>::const_iterator it_parent_parent = const_cast<Identifier*>(elem)->parents_.begin(); it_parent_parent != const_cast<Identifier*>(elem)->parents_.end(); ++it_parent_parent)
+        for (const Identifier* directParent : this->directParents_)
+        {
+            for (std::list<const Identifier*>::const_iterator it_parent_parent = const_cast<Identifier*>(directParent)->parents_.begin(); it_parent_parent != const_cast<Identifier*>(directParent)->parents_.end(); ++it_parent_parent)
                 this->addIfNotExists(expectedIdentifierTrace, *it_parent_parent);
-            this->addIfNotExists(expectedIdentifierTrace, elem);
+            this->addIfNotExists(expectedIdentifierTrace, directParent);
         }
 
@@ -285,6 +285,6 @@
 
             orxout(internal_warning) << "  Actual trace (after creating a sample instance):" << endl << "    ";
-            for (const auto & elem : this->parents_)
-                orxout(internal_warning) << " " << (elem)->getName();
+            for (const Identifier* parent : this->parents_)
+                orxout(internal_warning) << " " << parent->getName();
             orxout(internal_warning) << endl;
 
@@ -295,6 +295,6 @@
 
             orxout(internal_warning) << "  Direct parents (according to class hierarchy definitions):" << endl << "    ";
-            for (const auto & elem : this->directParents_)
-                orxout(internal_warning) << " " << (elem)->getName();
+            for (const Identifier* directParent : this->directParents_)
+                orxout(internal_warning) << " " << directParent->getName();
             orxout(internal_warning) << endl;
         }
Index: /code/branches/cpp11_v2/src/libraries/core/class/Identifier.h
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/class/Identifier.h	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/class/Identifier.h	(revision 10916)
@@ -462,6 +462,6 @@
 
         if (updateChildren)
-            for (const auto & elem : this->getChildren())
-                (elem)->updateConfigValues(false);
+            for (const Identifier* child : this->getChildren())
+                child->updateConfigValues(false);
     }
 
Index: /code/branches/cpp11_v2/src/libraries/core/class/IdentifierManager.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/class/IdentifierManager.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/class/IdentifierManager.cc	(revision 10916)
@@ -93,7 +93,6 @@
         {
             Context temporaryContext(nullptr);
-            for (auto identifier : this->identifiers_)
+            for (Identifier* identifier : this->identifiers_)
             {
-                
                 if (identifier->isInitialized())
                     continue;
@@ -127,6 +126,6 @@
 
         // finish the initialization of all identifiers
-        for (const auto & initializedIdentifier : initializedIdentifiers)
-            (initializedIdentifier)->finishInitialization();
+        for (Identifier* initializedIdentifier : initializedIdentifiers)
+            initializedIdentifier->finishInitialization();
 
         // only check class hierarchy in dev mode because it's an expensive operation and it requires a developer to fix detected problems anyway.
@@ -144,26 +143,26 @@
     {
         // check if there are any uninitialized identifiers remaining
-        for (const auto & elem : this->identifiers_)
-            if (!(elem)->isInitialized())
-                orxout(internal_error) << "Identifier was registered late and is not initialized: " << (elem)->getName() << " / " << (elem)->getTypeInfo().name() << endl;
+        for (Identifier* identifier : this->identifiers_)
+            if (!identifier->isInitialized())
+                orxout(internal_error) << "Identifier was registered late and is not initialized: " << identifier->getName() << " / " << identifier->getTypeInfo().name() << endl;
 
         // for all initialized identifiers, check if a sample instance behaves as expected according to the class hierarchy
         Context temporaryContext(nullptr);
-        for (const auto & initializedIdentifier : initializedIdentifiers)
+        for (Identifier* initializedIdentifier : initializedIdentifiers)
         {
-            if (!(initializedIdentifier)->hasFactory())
+            if (!initializedIdentifier->hasFactory())
                 continue;
 
-            Identifiable* temp = (initializedIdentifier)->fabricate(&temporaryContext);
-
-            for (const auto & elem : this->identifiers_)
+            Identifiable* temp = initializedIdentifier->fabricate(&temporaryContext);
+
+            for (Identifier* identifier : this->identifiers_)
             {
-                bool isA_AccordingToRtti = (elem)->canDynamicCastObjectToIdentifierClass(temp);
-                bool isA_AccordingToClassHierarchy = temp->isA((elem));
+                bool isA_AccordingToRtti = identifier->canDynamicCastObjectToIdentifierClass(temp);
+                bool isA_AccordingToClassHierarchy = temp->isA(identifier);
 
                 if (isA_AccordingToRtti != isA_AccordingToClassHierarchy)
                 {
-                    orxout(internal_error) << "Class hierarchy does not match RTTI: Class hierarchy claims that " << (initializedIdentifier)->getName() <<
-                        (isA_AccordingToClassHierarchy ? " is a " : " is not a ") << (elem)->getName() << " but RTTI says the opposite." << endl;
+                    orxout(internal_error) << "Class hierarchy does not match RTTI: Class hierarchy claims that " << initializedIdentifier->getName() <<
+                        (isA_AccordingToClassHierarchy ? " is a " : " is not a ") << identifier->getName() << " but RTTI says the opposite." << endl;
                 }
             }
@@ -184,6 +183,6 @@
     {
         orxout(internal_status) << "Destroy class-hierarchy" << endl;
-        for (const auto & elem : this->identifiers_)
-            (elem)->reset();
+        for (Identifier* identifier : this->identifiers_)
+            identifier->reset();
     }
 
@@ -260,7 +259,7 @@
     {
         // TODO: use std::type_index and a map to find identifiers by type_info (only with c++11)
-        for (const auto & elem : this->identifiers_)
-            if ((elem)->getTypeInfo() == typeInfo)
-                return (elem);
+        for (Identifier* identifer : this->identifiers_)
+            if (identifer->getTypeInfo() == typeInfo)
+                return identifer;
         return nullptr;
     }
Index: /code/branches/cpp11_v2/src/libraries/core/command/ArgumentCompletionFunctions.cc
===================================================================
--- /code/branches/cpp11_v2/src/libraries/core/command/ArgumentCompletionFunctions.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/libraries/core/command/ArgumentCompletionFunctions.cc	(revision 10916)
@@ -77,6 +77,6 @@
             bool groupIsVisible(const std::map<std::string, ConsoleCommand*>& group, bool bOnlyShowHidden)
             {
-                for (const auto & elem : group)
-                    if (elem.second->isActive() && elem.second->hasAccess() && (!elem.second->isHidden())^bOnlyShowHidden)
+                for (const auto& mapEntry : group)
+                    if (mapEntry.second->isActive() && mapEntry.second->hasAccess() && (!mapEntry.second->isHidden())^bOnlyShowHidden)
                         return true;
 
@@ -100,7 +100,7 @@
                 // get all the groups that are visible (except the shortcut group "")
                 const std::map<std::string, std::map<std::string, ConsoleCommand*>>& commands = ConsoleCommandManager::getInstance().getCommands();
-                for (const auto & command : commands)
-                    if (groupIsVisible(command.second, bOnlyShowHidden) && command.first != "" && (fragmentLC == "" || getLowercase(command.first).find(fragmentLC) == 0))
-                        groupList.push_back(ArgumentCompletionListElement(command.first, getLowercase(command.first)));
+                for (const auto& mapEntry : commands)
+                    if (groupIsVisible(mapEntry.second, bOnlyShowHidden) && mapEntry.first != "" && (fragmentLC == "" || getLowercase(mapEntry.first).find(fragmentLC) == 0))
+                        groupList.push_back(ArgumentCompletionListElement(mapEntry.first, getLowercase(mapEntry.first)));
 
                 // now add all shortcuts (in group "")
@@ -113,7 +113,7 @@
 
                     // add the shortcuts
-                    for (const auto & elem : it_group->second)
-                        if (elem.second->isActive() && elem.second->hasAccess() && (!elem.second->isHidden())^bOnlyShowHidden && (fragmentLC == "" || getLowercase(elem.first).find(fragmentLC) == 0))
-                            groupList.push_back(ArgumentCompletionListElement(elem.first, getLowercase(elem.first)));
+                    for (const auto& mapEntry : it_group->second)
+                        if (mapEntry.second->isActive() && mapEntry.second->hasAccess() && (!mapEntry.second->isHidden())^bOnlyShowHidden && (fragmentLC == "" || getLowercase(mapEntry.first).find(fragmentLC) == 0))
+                            groupList.push_back(ArgumentCompletionListElement(mapEntry.first, getLowercase(mapEntry.first)));
                 }
 
@@ -146,7 +146,7 @@
                 if (it_group != ConsoleCommandManager::getInstance().getCommands().end())
                 {
-                    for (const auto & elem : it_group->second)
-                        if (elem.second->isActive() && elem.second->hasAccess() && (!elem.second->isHidden())^bOnlyShowHidden)
-                            commandList.push_back(ArgumentCompletionListElement(elem.first, getLowercase(elem.first)));
+                    for (const auto& mapEntry : it_group->second)
+                        if (mapEntry.second->isActive() && mapEntry.second->hasAccess() && (!mapEntry.second->isHidden())^bOnlyShowHidden)
+                            commandList.push_back(ArgumentCompletionListElement(mapEntry.first, getLowercase(mapEntry.first)));
                 }
 
@@ -281,5 +281,5 @@
 
             const std::set<std::string>& names = SettingsConfigFile::getInstance().getSectionNames();
-            for (const auto & name : names)
+            for (const std::string& name : names)
                 sectionList.push_back(ArgumentCompletionListElement(name, getLowercase(name)));
 
